<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "account_provider".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "AccountProvider".
 *
 * Columns in table "account_provider" available as properties of the model,
 * followed by relations of table "account_provider" available as properties of the model.
 *
 * @property integer $id
 * @property integer $account_id
 * @property integer $provider_id
 * @property integer $all_practices
 * @property string $date_added
 *
 * @property Account $account
 * @property Provider $provider
 */
abstract class BaseAccountProvider extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'account_provider';
    }

    public static function representingColumn()
    {
        return array('account_id', 'provider_id');
    }

    public function rules()
    {
        return array(
            array('account_id, provider_id', 'required'),
            array('account_id, provider_id, all_practices', 'numerical', 'integerOnly' => true),
            array('research_status', 'default', 'setOnEmpty' => true, 'value' => null),
            array(
                'id, provider_id, account_full_name, all_practices, date_added, research_status',
                'safe',
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'account_id' => Yii::t('app', 'Account'),
            'provider_id' => Yii::t('app', 'Provider'),
            'all_practices' => Yii::t('app', 'All Practices'),
            'date_added' => Yii::t('app', 'Date Added'),
            'research_status' => Yii::t('app', 'Research Status'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;
        $criteria->with = array('account', 'provider');

        // this is to enable eager loading
        if (!empty($this->account_full_name)) {
            $criteria->addSearchCondition('concat(account.first_name, " ", account.last_name)', $this->account_full_name);
        }

        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->compare('provider.first_last', $this->provider_id, true);
        } elseif (intval($this->provider_id)) {
            $criteria->compare('provider_id', $this->provider_id);
        }
        if (intval($this->account_id)) {
            $criteria->compare('account_id', $this->account_id);
        }
        $criteria->compare('all_practices', $this->all_practices);
        $criteria->compare('t.date_added', $this->date_added, true);

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public function getAccount_Full_Name()
    {
        return Account::model()->first_name . ' ' . Account::model()->last_name;
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'AccountProvider|AccountsProviders', $n);
    }
}
